<template>
  <div class="white-block">
    <div class="padding" @click="showBeneficailInfo">
      <h3>Бенефициарный владелец
        <img
          src="static/img/head/content/tooltip.png"
          v-tooltip.right-start="{
          content:
          '<p>' + 'При отсутствии бенефициарного владельца физического лица, его бенефициарным владельцем признаётся само это лицо.' +
          'Физическое лицо, которое в конечном счете прямо или косвенно имеет возможность контролировать действия клиента (лично или по договору).'
          + '</p>',
          targetClasses: 'registration-tooltip-icon',
          delay: {show: 250, hide: 500},
          classes: 'registration-tooltip',
          trigger: 'click hover',
          }"
          @click.stop="$event.preventDefault"
        >
        <img style="float: right; margin-top: -5px;" :src="arrow">
      </h3>
    </div>
    <hr/>
    <div class="padding" v-show="beneficialInfoShow">

      <div class="row">
        <div class="column">
          <label for="beneficial">Наличие бенефириарного владельца физического лица</label>
          <multiselect v-model="fieldBeneficial"
                       :options="beneficialStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="beneficial"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getBeneficial"
                       :vValidateRules = "'required'"
                       name="beneficial"
                       :value="beneficialInfo"
                       data-code="beneficial.stateNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('beneficial')">
            {{ vErrors.first('beneficial') }}
          </validate-message>
        </div>
      </div>

      <div v-if="$user.beneficial.state">

        <div class="row">

          <div class="columns four">
            <label for="lastName">Фамилия</label>
            <input type="text"
                   name="фамилия бенефициала"
                   id="lastName"
                   :value="$user.beneficial.lastName"
                   v-validate="'required|cyrillic|min:2|max:50'"
                   :class="getValidateClass('фамилия бенефициала')"
                   @input.prevent="rusLangAndSetValue"
                   data-code="beneficial.lastNameTooShort, beneficial.lastNameTooLong, beneficial.lastNameInvalidFormat"
            />
            <validate-message v-show="vErrors.has('фамилия бенефициала')">
              {{ vErrors.first('фамилия бенефициала') }}
            </validate-message>
          </div>

          <div class="columns four">
            <label for="firstName">Имя</label>
            <input type="text"
                   name="имя бенефицала"
                   id="firstName"
                   :value="$user.beneficial.firstName"
                   v-validate="'required|cyrillic|min:2|max:50'"
                   :class="getValidateClass('имя бенефицала')"
                   @input.prevent="rusLangAndSetValue"
                   data-code="beneficial.firstNameTooShort, beneficial.firstNameTooLong, beneficial.firstNameInvalidFormat"
            />
            <validate-message v-show="vErrors.has('имя бенефицала')">
              {{ vErrors.first('имя бенефицала') }}
            </validate-message>
          </div>

          <div class="columns four">
            <label for="middleName">Отчество</label>
            <input type="text"
                   name="отчество бенефициала"
                   id="middleName"
                   :value="$user.beneficial.middleName"
                   v-validate="'required|cyrillic|min:2|max:50'"
                   :class="getValidateClass('отчество бенефициала')"
                   @input.prevent="rusLangAndSetValue"
                   data-code="beneficial.middleNameTooShort, beneficial.middleNameTooLong, beneficial.middleNameInvalidFormat"
            />
            <validate-message v-show="vErrors.has('отчество бенефициала')">
              {{ vErrors.first('отчество бенефициала') }}
            </validate-message>
          </div>

      </div>

        <div class="row">

          <div class="columns four">
            <label for="passport">Серия и номер</label>

            <input
              type="text"
              name="паспорт бенефициала"
              id="passport"
              v-validate="'required|serialAndNumber'"
              :class="getValidateClass('паспорт бенефициала')"
              v-model="$user.beneficial.passport"
              v-mask="'#### ######'"
              :guide="true"
              placeholder="1234 567890"
              :keepCharPositions="true"
              data-code="beneficial.passportInvalidFormat, beneficial.passportTooShort, beneficial.passportTooLong"
            >
            <validate-message v-show="vErrors.has('паспорт бенефициала')">
              {{ vErrors.first('паспорт бенефициала') }}
            </validate-message>
          </div>

          <div class="columns four">

            <label for="passportDivisionCode">Код подразделения</label>

            <input
              type="text"
              name="код подразделения паспорта бенефициала"
              id="passportDivisionCode"
              v-validate="'required|passportCode'"
              :class="getValidateClass('код подразделения паспорта бенефициала')"
              v-model="$user.beneficial.passportDivisionCode"
              v-mask="'###-###'"
              :guide="true"
              placeholder="123-456"
              :keepCharPositions="true"
              data-code="beneficial.passportDivisionCodeInvalidFormat, beneficial.passportDivisionCodeTooShort, beneficial.passportDivisionCodeTooLong"
            >
            <validate-message v-show="vErrors.has('код подразделения паспорта бенефициала')">
              {{ vErrors.first('код подразделения паспорта бенефициала') }}
            </validate-message>

          </div>

          <div class="columns four">
            <label for="passportDateOfIssue">Дата выдачи</label>

            <input
                type="text"
                name="дата выдачи паспорта бенефициала"
                id="passportDateOfIssue"
                v-validate="datePassport"
                :class="getValidateClass('дата выдачи паспорта бенефициала')"
                v-model="$user.beneficial.passportDateOfIssue"
                v-mask="'##.##.####'"
                :guide="true"
                :keepCharPositions="true"
                placeholder="ДД.ММ.ГГГГ"
                data-code="beneficial.passportDateOfIssueInvalidDateFormat, beneficial.passportDateOfIssueLowerThenMin, beneficial.passportDateOfIssueGreaterThenMax"
              >
              <validate-message v-show="vErrors.has('дата выдачи паспорта бенефициала')">
                {{ vErrors.first('дата выдачи паспорта бенефициала') }}
              </validate-message>

          </div>

        </div>

      </div>

    </div>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import Multiselect from '@/UI/Multiselect'


  export default {
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration
    ],
    components: {
      ValidateMessage,
      Multiselect
    },
    data () {
      return {
        datePassport: `required|date_format_check|date_between_passport`,
        fieldBeneficial: [{id: 1, title: 'Я сам(а)', status: false}],
        beneficialStatus: [
          {id: 1, title: 'Я сам(а)', status: false},
          {id: 2, title: 'Другое лицо', status: true}
        ],
        beneficialInfoShow: false,
        arrow: 'static/img/loan/modal-down.png'
      }
    },
    computed: {
      beneficialInfo () {
        (this.$user.beneficial.state === false) ? this.fieldBeneficial = this.beneficialStatus[[0]] : this.fieldBeneficial = this.beneficialStatus[[1]]
      }
    },
    methods: {
      showBeneficailInfo () {
        this.beneficialInfoShow = !this.beneficialInfoShow
        if (this.beneficialInfoShow === false) {
          this.arrow = 'static/img/loan/modal-down.png'
        } else {
          this.arrow = 'static/img/loan/modal-up.png'
        }
      },
      getBeneficial (arg) {
        console.log('arg', arg)
        if (!arg.status) {
          let face = this.$user.beneficial
          Object.keys(face).forEach(key => face[key] = null)
        }
        this.$user.beneficial.state = arg.status
      },
      rusLangAndSetValue (e) {
        e.preventDefault()
        if (/^[а-яА-Я]+$/.test(e.target.value)) {
          this.$user.beneficial[e.target.id] = e.target.value
        }
        if (e.target.value === '') {
          this.$user.beneficial[e.target.id] = e.target.value
        }
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
      this.$user.validate.step3.beneficialInformation = true
    },
    updated () {
      this.$user.validate.step3.beneficialInformation = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    },
    name: 'beneficial-information'
  }
</script>

<style scoped>

</style>
